/*
 * Boost Software License - Version 1.0 - August 17th, 2003
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * 
 */

#include "mathematica++/symbol.h"
#include "mathematica++/m.h"

mathematica::symbol::symbol(const std::string& name): _name(name){}
mathematica::symbol::symbol(const mathematica::symbol& other): _name(other._name){}

mathematica::symbol mathematica::symbol::True(){
    return mathematica::symbol("True");
}

mathematica::symbol mathematica::symbol::False(){
    return mathematica::symbol("False");
}

mathematica::symbol mathematica::symbol::Pi(){
    return mathematica::symbol("Pi");
}

mathematica::symbol mathematica::symbol::E(){
    return mathematica::symbol("E");
}

mathematica::symbol mathematica::symbol::I(){
    return mathematica::symbol("I");
}

mathematica::symbol mathematica::symbol::Infinity(){
    return mathematica::symbol("Infinity");
}


mathematica::symbol mathematica::symbol::var(const std::string& name){
    return mathematica::symbol(name);
}

std::string mathematica::symbol::name() const{
    return _name;
}

mathematica::m mathematica::symbol::operator=(const mathematica::m& rhs){
    return mathematica::m("Set")(*this, rhs);
}

